;*****************************************************************************
;*                                                                           *
;* PROT - A softdog killer                                                   *
;* Copyright (C) 1996, by Li Wen_xian                                        *
;* All rights reserved                                                       *
;*                                                                           *
;* This file is: CODE16.ASM, the 16 bit DOS entry/exit code.                 *
;*                                                                           *
;*****************************************************************************

INCLUDE         EQUMAC.INC
CODE16_FILE     EQU    1
INCLUDE         EXTERNAL.INC

CSEG            SEGMENT
                ASSUME CS:CSEG,DS:CSEG
                PUBLIC BACK16
                PUBLIC PM2REAL
                PUBLIC ENTRY
                PUBLIC _TSR
                PUBLIC _RTCSIP
BEG16           EQU     $

IDTSAV          DF      0       ;space to save old IDT
XZRO            DF      0       ;constant to inhibit IDT

;area to save stack pointer
SOFFSAV         DW      0
SSEGSAV         DW      0

TEMP            EQU     THIS FWORD      ;space to load GDT
TLIM            DW      GDTLEN
TEMD            DD      0

;old keyboard interrupt vector -- we have to catch reboots
KEYCHAIN        EQU     THIS DWORD
KEYOFF          DW      ?
KEYSEG          DW      ?

INTM            DB      0       ;interrupt mask - pic 1
INTMAT          DB      0       ;interrupt mask - AT pic 2

;psp
PSP             DW      0
PS2             DB      0       ;1 if PS/2 w/Microchannel
PC386           DB      0       ;1 if INTEL INBOARD PC found
IBPC            DB      'INBRDPC%',0    ;device name for inboard
_RTCSIP         DD      0       ;CS & IP   0
                DW      0       ;FLAGS     4
                DW      0       ;ES        6
                DW      0       ;DS        8
                DW      0       ;SS        A
                DW      0       ;BP        C
                DW      0       ;SP        E
                DW      0       ;DI       10
                DW      0       ;SI       12
                DW      0       ;DX       14
                DW      0       ;CX       16
                DW      0       ;BX       18
                DW      0       ;AX       1A
;error messages
NOT386M         DB      'Error: this program requires an'
                DB      '80386 or 80486'
                DB      'processor.',13,10,'$'
VM86M           DB      'Error: this program will not execute '
                DB      'in VM86 mode!!'
                DB      13,10,'$'
;cane messages
VERS            DB      'Softdog killer v1.0 Copyright (C) 1996, by Li Wenxian',13,10
                DB      'All Rights Reserved',13,10,'$'
HELPMSG         DB      '-------------------------HELP------------------------',13,10
                DB      '  CANE       -----Emulate the softdog',13,10
                DB      '  CANE /Axxx -----Analyse the softdog,xxx=extend mem kept',13,10
                DB      '  CANE /R    -----Read the softdog file',13,10
                DB      '  CANE /W    -----Write the softdog file',13,10
                DB      '  CANE /U    -----Free memory and to dos',13,10
                DB      '  CANE /H    -----Help',13,10,'$'
NOTINMEM        DB      'Softdog killer not in memory!!',13,10,'$'
RIGHTFREE       DB      'Softdog killer has been freed successfully',13,10,'$'
ERRORFREE       DB      'Softdog killer cannot be freed',13,10,'$'
DATAERROR       DB      'File cane.lad error!!',13,10,'$'
NOTCORRECT      DB      'Illegal parametre!!!',13,10,'$'
MEMORYLACK      DB      'Memory not enough!!!',13,10,'$'
FILENAME        DB      'CANE0378.LAD',0
GDTAREA         DB      16 DUP(0)
                DW      0FFFFH          ;src seg limit
                DW      0               ;src ptr low
                DB      0               ;src ptr high
                DB      93H             ;src rights
                DW      0
                DW      0FFFFH          ;desc seg limit
                DW      0               ;desc ptr low
                DB      0               ;desc ptr high
                DB      93H             ;desc rights
                DW      0
                DB      16 DUP(0)
_HANDLE         DW      0
_EXTENDADDR     DD      0
_EXTENDLEN      DD      0
_EXTSIZE        DW      0
_WRITECOUNTER   DD      0
_READCOUNTER    DD      0
RWBUFFER        DB      400H    DUP (0)

;16 bit ss/sp for return to real mode
LOAD16          DD      OFFSET SSEG1
                DW      SEL_RDATA

;**************************************************************************
;*            Begin program                                               *
;**************************************************************************
ENTRY           LABEL FAR

START           PROC    NEAR
                CALL    SETPARALLEL
                CALL    CHECKEXT
                CALL    GETPARA      ;get para 0: cane,    1: cane /a, 2: cane /w
                                     ;         3: cane /u, 4: cane /?
                CMP     AL,0
                JZ      EMULATION
                CMP     AL,1
                JZ      ANALYSIS
                CMP     AL,2
                JZ      WRITEFILE
                CMP     AL,3
                JZ      CANEQUIT
                CMP     AL,4
                JZ      CANEHELP
                CMP     AL,5
                JZ      READFILE
                MOV     AX,4C00H
                INT     21H
EMULATION:
                MOV     AX,DAT32
                MOV     FS,AX
                MOV     FS:EXEFLAG,0   ;emulation
                JMP     CANESTART
ANALYSIS:
                MOV     AX,DAT32
                MOV     FS,AX
                MOV     FS:EXEFLAG,1   ;analysis
                JMP     CANESTART
WRITEFILE:
                CALL    WRITEDATAFILE
                MOV     AX,4C00H
                INT     21H
READFILE:
                CALL    READDATAFILE
                MOV     AX,4C00H
                INT     21H
CANEQUIT:
                CALL    FREESPACE
                MOV     AX,4C00H
                INT     21H

CANEHELP:
                CALL    HELPUSER
                MOV     AX,4C00H
                INT     21H

CANESTART:
                PUSH    CS            ;set up DS segment,save PSP
                POP     DS

                MOV     AX,ES
                MOV     PSP,AX        ;save PSP
                MOV     BX,DAT32
                MOV     ES,BX
                MOV     ES:_PSP,AX    ;save PSP to global var

                ;check to see if we are running on a 386/486
                XOR     AX,AX
                PUSH    AX
                POPF
                PUSHF
                POP     AX
                AND     AX,0F000H
                CMP     AX,0F000H
                JNZ     SHORT NOT86
NOT386:
                MOV     DX,OFFSET NOT386M
NOT386EXIT:
                MOV     AH,9
                INT     21H
                MOV     AX,4C80H
                INT     21H

                ;here if it is 286 or better
NOT86:
                MOV     AX,0F000H
                PUSH    AX
                POPF
                PUSHF
                POP     AX
                AND     AX,0F000H
                JZ      NOT386

                ;if we got here we are on an 80386/486
                ;check PM flag
                SMSW    AX
                AND     AX,1            ;are we in protected mode?
                MOV     DX,OFFSET VM86M
                JNZ     NOT386EXIT

                ;Ok. we are clear to proceed
                ;See if we are on a Micro Channel PS/2
                MOV     AX,0C400H       ;get POS address
                INT     15H
                JC      SHORT TRYIB
                MOV     PS2,1
                JMP     SHORT ATSTYLE

                ;see if we are on an INTEL INBOARD/386 PC is so set flags in
                ;dat32 and in this segment
TRYIB:
                MOV     DX,OFFSET IBPC
                MOV     AX,3D00H
                INT     21H             ;try to open device driver

                ;jump if AT - CLASS machine
                JC      SHORT ATSTYLE
                MOV     BX,AX           ;close device
                MOV     AH,3EH
                INT     21H
                MOV     PC386,1
                MOV     ES:_PC386,1
ATSTYLE:
                ;display version information

                MOV     DX,OFFSET VERS
                MOV     AH,09H
                INT     21H

                ;Create segments
                PUSH    GDTSEG
                POP     ES
                MOV     EDX,OFFSET GDT  ;es:edx gdt address
                MOV     EBX,CS
                SHL     EBX,4           ;calc segment base address
                MOV     ECX,0FFFFH      ;64 K limit (don't change)
                MOV     AH,ER_CODE      ;read/exec code seg
                XOR     AL,AL           ;size 16
                MOV     SI,SEL_CODE16   ;descriptor
                CALL    MAKE_DESC       ;make code seg(16 bit/real)
                XOR     EBX,EBX         ;base
                MOV     SI,SEL_DATA0    ;descriptor
                XOR     ECX,ECX
                DEC     ECX             ;ecx=ffffffff
                MOV     AL,1            ;size 32
                MOV     AH,RW_DATA
                CALL    MAKE_DESC       ;make data (4G @ zero base)
                XOR     EAX,EAX
                INT     12H             ;get the actual mem
                MOVZX   ECX,AX
                SHL     ECX,10

                ;get free memory segment
                LOADFREE BX            ;base
                SUB     ECX,EBX
                DEC     ECX            ;limit
                MOV     SI,SEL_FREE    ;descriptor
                MOV     AL,1           ;size 32
                MOV     AH,RW_DATA
                CALL    MAKE_DESC
                XOR     EAX,EAX
                MOV     AH,88H         ;get top of extended memory
                INT     15H
                SHL     EAX,10
                OR      EAX,EAX        ;any extended present?
                MOV     ECX,EAX
                JNZ     SHORT EXTPRES
                MOV     ECX,1
EXTPRES:
                DEC     ECX            ;limit
                MOV     EBX,100000H    ;base
                MOV     SI,SEL_EXT     ;descriptor
                MOV     AL,1           ;size 32
                MOV     AH,RW_DATA
                CALL    MAKE_DESC      ;make extended memory
                XOR     EBX,EBX
                MOV     BX,SEG32
                SHL     EBX,4          ;base
                MOV     ECX,SEG32LEN   ;limit
                MOV     AH,ER_CODE
                MOV     AL,1           ;size 32
                MOV     SI,SEL_CODE32  ;descriptor
                CALL    MAKE_DESC      ;32 bit code segment
                XOR     EBX,EBX
                MOV     BX,USERCODE
                SHL     EBX,4          ;base
                MOV     ECX,USERCODELEN  ;limit
                MOV     AH,ER_CODE
                MOV     AL,1           ;size 32
                MOV     SI,SEL_UCODE   ;descriptor
                CALL    MAKE_DESC      ;make user code
                XOR     EBX,EBX
                MOV     BX,USERDATA
                SHL     EBX,4          ;base
                MOV     ECX,USERDATALEN ;limit
                MOV     AH,RW_DATA
                MOV     AL,1
                MOV     SI,SEL_UDATA    ;descriptor
                CALL    MAKE_DESC       ;make user data
                XOR     EBX,EBX
                MOV     BX,SS32
                SHL     EBX,4           ;always para align stacks !
                MOV     ECX,SSEG32LEN
                MOV     AH,RW_DATA      ;stack seg is data type
                MOV     AL,1
                MOV     SI,SEL_STACK
                CALL    MAKE_DESC       ;make stack

                ;16 bit data for return to real mode
                XOR     EBX,EBX
                MOV     BX,SSEG
                SHL     EBX,4           ;base

                ;real mode limit (don't change)
                MOV     ECX,0FFFFH      ;limit
                XOR     AL,AL           ;size 16bit
                MOV     AH,RW_DATA
                MOV     SI,SEL_RDATA
                CALL    MAKE_DESC
                XOR     EBX,EBX
                MOV     BX,GDTSEG
                SHL     EBX,4
                ADD     EBX,OFFSET GDT
                MOV     ECX,(GDTLEN)
                MOV     AL,1
                MOV     AH,RW_DATA
                MOV     SI,SEL_GDT
                CALL    MAKE_DESC
                MOV     AX,500H         ;set video to page 0
                INT     10H
                MOV     AH,0FH          ;get mode
                INT     10H
                MOV     EBX,0B0000H     ;monochrome
                CMP     AL,7            ;check for mono
                JZ      SHORT VIDEOCONT
                MOV     EBX,0B8000H
VIDEOCONT:
                MOV     ECX,3999        ;limit for text page
                MOV     AL,1
                MOV     AH,RW_DATA
                MOV     SI,SEL_VIDEO
                CALL    MAKE_DESC       ;make video segment
                XOR     EBX,EBX
                MOV     BX,DAT32
                SHL     EBX,4
                MOV     ECX,DAT32LEN
                MOV     AH,RW_DATA
                MOV     AL,1
                MOV     SI,SEL_DATA
                CALL    MAKE_DESC
                XOR     EBX,EBX
                MOV     BX,IDTABLE
                SHL     EBX,4
                MOV     ECX,IDTLEN
                MOV     AH,RW_DATA
                MOV     AL,1
                MOV     SI,SEL_IDT
                CALL    MAKE_DESC
                XOR     EBX,EBX
                MOV     BX,ISR
                SHL     EBX,4
                MOV     ECX,ISRLEN
                MOV     AH,ER_CODE
                MOV     AL,1
                MOV     SI,SEL_ICODE
                CALL    MAKE_DESC

                XOR     EBX,EBX
                MOV     BX,ISR
                SHL     EBX,4
                MOV     ECX,ISRLEN
                MOV     AH,RW_DATA
                MOV     AL,1
                MOV     SI,SEL_ISR
                CALL    MAKE_DESC     ;The alias of ISR

                XOR     EBX,EBX
                MOV     BX,TSSSEG
                SHL     EBX,4

                ;ceat TSSs
                MOV     ECX,TSSLEN
                MOV     AH,RW_DATA
                MOV     AL,1
                MOV     SI,SEL_TSS0
                CALL    MAKE_DESC
                MOV     AH,TSS_DESC
                MOV     SI,TSS0
                CALL    MAKE_DESC
                ADD     EBX,OFFSET TSS1BEG
                MOV     SI,TSS1
                MOV     ECX,TSSLEN
                CALL    MAKE_DESC
                MOV     SI,SEL_TSS1
                MOV     AH,RW_DATA
                CALL    MAKE_DESC

                ;psp
                MOVZX   EBX,PSP
                SHL     EBX,4
                MOV     ECX,255
                MOV     AH,RW_DATA
                MOV     AL,1
                MOV     SI,SEL_PSP
                CALL    MAKE_DESC

                ;Environment segment
                PUSH    ES
                MOV     ES,PSP
                XOR     EBX,EBX
                MOV     BX,ES:[2CH]
                MOV     AX,BX
                SHL     EBX,4
                DEC     AX
                MOV     ES,AX
                XOR     ECX,ECX
                MOV     CX,ES:[3]
                SHL     ECX,4
                DEC     ECX            ;get limit form arena header
                MOV     SI,SEL_ENV
                POP     ES
                MOV     AL,1
                MOV     AH,RW_DATA
                CALL    MAKE_DESC      ;make environment segment

                ;turn on A20
                ;MOV     AL,1
                ;CALL    SETA20

                ;no interrupts until prot mode
                CLI
                MOV     SSEGSAV,SS

                ;save sp for triumphant return to r/m
                MOV     SOFFSAV,SP
                SIDT    IDTSAV
                LIDT    XZRO          ;save and load IDT
                XOR     EBX,EBX
                MOV     BX,GDTSEG
                SHL     EBX,4
                ADD     EBX,OFFSET GDT
                MOV     TEMD,EBX
                LGDT    TEMP          ;set up GDT
                MOV     EAX,CR0
                OR      EAX,1         ;switch to prot model
                MOV     CR0,EAX

                ;jump to load CS and filush prefetch
                JMPABS SEL_CODE16,PROT1

PROT1:                                ;go!
                OPSIZ
                JMPABS32 SEL_CODE32,SEG32ENT   ;see program PROT.ASM

;****************************************************************************
;Jump here to return to real mode DOS.                                      *
;if desired AL can be set to a DOS exit code                                *
;****************************************************************************

BACK16          LABEL   FAR
                MOV     BL,AL
                CLI                     ;save exit code

                ;turn off debug (just in case)
                XOR     EAX,EAX
                MOV     DR7,EAX

                ;restore stack
                LSS     ESP,FWORD PTR CS:LOAD16
                MOV     AX,SEL_RDATA
                MOV     DS,AX
                MOV     ES,AX
                MOV     FS,AX
                MOV     GS,AX
                MOV     EAX,CR0

                ;return to real mode
                AND     EAX,07FFFFFF2H
                MOV     CR0,EAX

                ;jump to load CS and clear prefetch
                JMPABS CSEG,NEXTREAL
NEXTREAL        LABEL   FAR
                MOV     AX,CS
                MOV     DS,AX
                LIDT    IDTSAV          ;restore old IDT 0(3ff)

                ;clean up to go back to DOS
                LSS     SP,DWORD PTR SOFFSAV
                STI                     ;resume interrupt handling

                ;turn a20 back off
                XOR     AL,AL
                CALL    SETA20

                MOV     AH,4CH          ;blow this joint!
                MOV     AL,BL           ;get return code
                INT     21H             ;return to the planet of MSDOS

PM2REAL         LABEL   FAR
                CLI                     ;save exit code

                ;turn off debug (just in case)
                XOR     EAX,EAX
                MOV     DR7,EAX

                ;restore stack
                LSS     ESP,FWORD PTR CS:LOAD16
                MOV     AX,SEL_RDATA
                MOV     DS,AX
                MOV     ES,AX
                MOV     FS,AX
                MOV     GS,AX
                MOV     EAX,CR0

                ;return to real mode
                AND     EAX,07FFFFFF2H
                MOV     CR0,EAX

                ;jump to load CS and clear prefetch
                JMPABS CSEG,NEXTREAL2
NEXTREAL2       LABEL   FAR
                MOV     AX,CS
                MOV     DS,AX
                LIDT    IDTSAV          ;restore old IDT 0(3ff)

                ;clean up to go back to DOS
                LSS     SP,DWORD PTR SOFFSAV
                STI                     ;resume interrupt handling

                ;turn a20 back off
                XOR     AL,AL
                CALL    SETA20

                MOV     AX,WORD PTR CS:_RTCSIP[4]    ;OLD FLAG
                PUSH    AX
                POPF
                MOV     AX,WORD PTR CS:_RTCSIP[6]    ;OLD ES
                MOV     ES,AX
                MOV     AX,WORD PTR CS:_RTCSIP[8]    ;OLD DS
                MOV     DS,AX
                MOV     AX,WORD PTR CS:_RTCSIP[0AH]  ;OLD SS
                MOV     SS,AX
                MOV     AX,WORD PTR CS:_RTCSIP[0CH]  ;OLD BP
                MOV     BP,AX
                MOV     AX,WORD PTR CS:_RTCSIP[0EH]  ;OLD SP
                MOV     SP,AX
                MOV     DI,WORD PTR CS:_RTCSIP[10H]  ;DI
                MOV     SI,WORD PTR CS:_RTCSIP[12H]  ;SI
                MOV     DX,WORD PTR CS:_RTCSIP[14H]  ;DX
                MOV     CX,WORD PTR CS:_RTCSIP[16H]  ;CX
                MOV     BX,WORD PTR CS:_RTCSIP[18H]  ;BX
                MOV     AX,WORD PTR CS:_RTCSIP[1AH]  ;AX
                JMP     DWORD PTR CS:_RTCSIP

START           ENDP

;****************************************************************************
;Routine to control A20 line                                                *
;AL=1 to turn A20 on (enable)                                               *
;AL=0 to turn A20 off (disable)                                             *
;returns ZF=1 if error; AX destroyed (and maybe CX)                         *
;****************************************************************************

SETA20          PROC    NEAR
                ASSUME CS:CSEG,DS:CSEG
                CMP     PS2,0
                JZ      SHORT NOTPS2A20
                MOV     AH,AL
                OR      AL,AL
                IN      AL,92H
                JZ      SHORT PS2OFF
                OR      AL,2
                JMP     SHORT PS2SET
PS2OFF:         AND     AL,0FDH
PS2SET:         OUT     92H,AL
                XOR     CX,CX
PS2WAIT:        IN      AL,92H
                SHR     AL,1
                CMP     AL,AH
                JZ      SHORT PS2OUT
                DEC     CX
                JNZ     PS2WAIT
                RET
PS2OUT:         OR      AL,1
                RET
NOTPS2A20:
                CMP     PC386,0
                JNZ     SHORT A20IBPC
                PUSH    CX
                MOV     AH,0DFH         ;A20 On
                OR      AL,AL
                JNZ     SHORT A20WAIT1
                MOV     AH,0DDH         ;A20 Off
A20WAIT1:
                CALL    KEYWAIT
                JZ      SHORT A20ERR
                MOV     AL,0D1H
                OUT     64H,AL
                CALL    KEYWAIT
                JZ      SHORT A20ERR
                MOV     AL,AH
                OUT     60H,AL
                CALL    KEYWAIT
                JZ      SHORT A20ERR
                MOV     AL,0FFH
                OUT     64H,AL
                CALL    KEYWAIT
A20ERR:         POP     CX
                RET

                ;A20 set for inboard PC
A20IBPC:
                OR      AL,AL
                MOV     AL,0DFH
                JNZ     SHORT A20SET
                MOV     AL,0DDH
A20SET:         OUT     60H,AL
                OR      AL,AL           ;make sure ZF is clear for
                RET
SETA20          ENDP

;****************************************************************************
;wait for keyboard controller ready, returns ZF=1, if timeout               *
;destroys CX and AL                                                         *
;****************************************************************************

KEYWAIT         PROC    NEAR
                XOR     CX,CX           ;maximum time out
KWAITLP:
                DEC     CX
                JZ      SHORT KEYEXIT
                IN      AL,64H
                AND     AL,2
                JNZ     KWAITLP
KEYEXIT:        OR      CX,CX
                RET
KEYWAIT         ENDP

;****************************************************************************
;This routine makes a descriptior                                           *
;ebx=base                                                                   *
;ecx=limit in bytes                                                         *
;es:edx=GDT address                                                         *
;al=size (0=16bit 1=32bit)                                                  *
;ah=AR byte                                                                 *
;SI=descriptor (T1 & DPL not important!)                                    *
;Auto sets and calculates G and limit                                       *
;****************************************************************************

MAKE_DESC       PROC    NEAR
                PUSHAD
                MOVZX   ESI,SI
                SHR     SI,3

                ;shift size to right bit position
                SHL     AL,6
                CMP     ECX,0FFFFFH             ;see if you need to set G bit
                JBE     SHORT OKLIMR
                SHR     ECX,12                  ;div by 4096
                OR      AL,80H                  ;set G bit
OKLIMR:         MOV     ES:[EDX+ESI*8],CX
                SHR     ECX,16
                OR      CL,AL
                MOV     ES:[EDX+ESI*8+6],CL
                MOV     ES:[EDX+ESI*8+2],BX
                SHR     EBX,16
                MOV     ES:[EDX+ESI*8+4],BL
                MOV     ES:[EDX+ESI*8+5],AH
                MOV     ES:[EDX+ESI*8+7],BH
                POPAD
                RET
MAKE_DESC       ENDP

;****************************************************************************
;* return to VM86 MODE                                                      *
;****************************************************************************

_TSR            PROC    FAR

                ;turn a20 back off
                XOR     AL,AL
                CALL    SETA20

                MOV     DX,09000H
                INT     27H
                RETF
_TSR            ENDP

GETPARA         PROC    NEAR
                PUSH    BX
                MOV     BX,0
LOOPSPACE:
                MOV     AL,[BX+81H]
                CMP     AL,0DH
                JZ      NOPARA
                CMP     AL,20H
                JNZ     SKIPSPACE
                INC     BX
                JMP     LOOPSPACE
SKIPSPACE:
                MOV     AL,[BX+81H]
                CMP     AL,'/'
                JZ      CORRECTPARA
                CMP     AL,'-'
                JZ      CORRECTPARA
                JMP     NOTCORRECTPARA
NOPARA:
                MOV     AL,0
                JMP     EXITPARA
CORRECTPARA:
                INC     BX
                MOV     AL,[BX+81H]
                OR      AL,20H
                CMP     AL,'a'
                JZ      PARA1
                CMP     AL,'w'
                JZ      PARA2
                CMP     AL,'u'
                JZ      PARA3
                CMP     AL,'h'
                JZ      PARA4
                CMP     AL,'r'
                JZ      PARA5
                JMP     NOTCORRECTPARA
PARA1:
                MOV     EDX,0
NEXTNUMBER:
                MOV     AL,[BX+82H]
                CMP     AL,30H
                JB      NUMBEROVER
                CMP     AL,39H
                JA      NUMBEROVER
                SUB     AL,30H
                MOV     AH,0
                MOVZX   EAX,AX
                SHL     EDX,1
                MOV     ECX,EDX
                SHL     EDX,2
                ADD     EDX,ECX
                ADD     EDX,EAX
                INC     BX
                JMP     NEXTNUMBER
NUMBEROVER:
                CMP     EDX,0
                JZ      NOTSETEXT
                SHL     EDX,10
                PUSH    ES
                MOV     AX,SEG PORTDATAADDR
                MOV     ES,AX
                MOVZX   EAX,CS:_EXTSIZE
                SHL     EAX,10
                SUB     EAX,EDX
                ADD     EAX,100000H
                MOV     ES:PORTDATAADDR,EAX
                ADD     EAX,2
                MOV     ES:CURBLOCKADDR,EAX
                POP     ES
                CMP     EAX,100000H
                JB      NOTCORRECTPARA
NOTSETEXT:
                MOV     AL,1
                JMP     EXITPARA
PARA2:
                MOV     AL,2
                JMP     EXITPARA
PARA3:
                MOV     AL,3
                JMP     EXITPARA
PARA4:
                MOV     AL,4
                JMP     EXITPARA
PARA5:
                MOV     AL,5
                JMP     EXITPARA
NOTCORRECTPARA:
                MOV     DX,OFFSET NOTCORRECT
                CALL    SHOWSTRING
                MOV     AL,0FFH
EXITPARA:
                POP     BX
                RET
GETPARA         ENDP

HELPUSER        PROC    NEAR
                PUSH    DS
                PUSH    CS
                POP     DS
                MOV     DX,OFFSET VERS
                MOV     AH,09H
                INT     21H
                MOV     DX,OFFSET HELPMSG
                MOV     AH,09H
                INT     21H
                POP     DS
                RET
HELPUSER        ENDP

FREESPACE       PROC    NEAR
                PUSH    BX
                PUSH    CX
                PUSH    DX
                PUSH    SI
                PUSH    DI
                PUSH    DS
                PUSH    ES

                MOV     AX,0FEFEH
                INT     21H        ;get TSR PSP
                CMP     AH,0FEH
                JZ      CANENOTINMEM
                MOV     DX,AX      ;PSP
                MOV     AX,0FEFFH
                INT     21H        ;back to real
                MOV     AX,CS
                MOV     DS,AX
                MOV     AH,52H
                INT     21H
                SUB     BX,2
                MOV     AX,ES:[BX]  ;seg of MB
                MOV     ES,AX
SPACELOOP:
                MOV     AL,ES:[0]   ;FLAG
                CMP     AL,5AH
                JZ      FINDISOVER  ;IS LAST
                CMP     WORD PTR ES:[1],DX
                JZ      FINDCANE    ;IS EQUAL
FREENEXT:
                MOV     AX,WORD PTR ES:[3]
                MOV     BX,ES
                ADD     AX,BX
                INC     AX
                MOV     ES,AX
                JMP     SPACELOOP
FINDCANE:
                PUSH    ES
                MOV     AX,ES
                INC     AX
                MOV     ES,AX
                MOV     AH,49H
                INT     21H
                POP     ES
                JMP     FREENEXT
FINDISOVER:
                MOV     DX,OFFSET RIGHTFREE
                CALL    SHOWSTRING
                MOV     AX,0
                JMP     EXITSPACE
CANENOTINMEM:
                MOV     DX,OFFSET NOTINMEM
                CALL    SHOWSTRING
                MOV     AX,1
EXITSPACE:
                POP     ES
                POP     DS
                POP     DI
                POP     SI
                POP     DX
                POP     CX
                POP     BX
                RET
FREESPACE       ENDP

SHOWSTRING      PROC    NEAR
                PUSH    DS
                PUSH    CS
                POP     DS
                MOV     AH,09H
                INT     21H
                POP     DS
                RET
SHOWSTRING      ENDP

WRITEDATAFILE   PROC    NEAR
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    DX
                PUSH    ES
                PUSH    DS

                PUSH    CS
                POP     DS
                MOV     DX,OFFSET FILENAME
                MOV     CX,0
                MOV     AH,3CH
                INT     21H             ;CREAT FILE
                JC      CREATERROR
                MOV     CS:_HANDLE,AX   ;HANDLE

                MOV     AX,0FEFDH
                INT     21H             ;get buffer address
                CMP     AH,0FEH
                JZ      CANENOTINMEM2
                MOV     CS:_EXTENDADDR,ECX  ;buffer address
                MOV     AX,CS
                MOVZX   EAX,AX
                SHL     EAX,4
                MOV     BX,OFFSET RWBUFFER
                MOVZX   EBX,BX
                ADD     EBX,EAX
                MOV     EAX,ECX
                MOV     ECX,0400H
                CALL    TRANSMITDATA        ;to base memory
                MOV     EAX,DWORD PTR RWBUFFER[2] ;length
                ADD     EAX,6
                MOV     CS:_EXTENDLEN,EAX
                MOV     CS:_WRITECOUNTER,0
NEXTFILEBLOCK:
                MOV     ECX,CS:_EXTENDLEN
                MOV     EAX,CS:_WRITECOUNTER
                SUB     ECX,EAX
                CMP     ECX,400H
                JB      ISLASTBLOCK
                MOV     ECX,400H
ISLASTBLOCK:
                MOV     EAX,CS:_WRITECOUNTER
                ADD     EAX,ECX
                MOV     CS:_WRITECOUNTER,EAX
                MOV     DX,OFFSET RWBUFFER
                MOV     BX,CS:_HANDLE   ;handle
                MOV     AH,40H
                INT     21H
                MOV     EAX,CS:_WRITECOUNTER
                CMP     EAX,CS:_EXTENDLEN
                JAE     CLOSEFILE
                MOV     AX,CS
                MOVZX   EAX,AX
                SHL     EAX,4
                MOV     BX,OFFSET RWBUFFER
                MOVZX   EBX,BX
                ADD     EBX,EAX
                MOV     EAX,CS:_EXTENDADDR
                MOV     ECX,CS:_WRITECOUNTER
                ADD     EAX,ECX
                MOV     ECX,0400H
                CALL    TRANSMITDATA   ;to base memory
                JMP     NEXTFILEBLOCK

CANENOTINMEM2:
                MOV     DX,OFFSET NOTINMEM
                CALL    SHOWSTRING
CLOSEFILE:
                MOV     BX,CS:_HANDLE
                MOV     AH,3EH
                INT     21H             ;CLOSE FILE
CREATERROR:
                POP     DS
                POP     ES
                POP     DX
                POP     CX
                POP     BX
                POP     AX
                RET
WRITEDATAFILE   ENDP

READDATAFILE    PROC    NEAR
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    DX
                PUSH    ES
                PUSH    DS

                PUSH    CS
                POP     DS
                MOV     DX,OFFSET FILENAME
                MOV     AL,0
                MOV     AH,3DH
                INT     21H             ;OPEN FILE
                JC      FILEERROR
                MOV     CS:_HANDLE,AX   ;HANDLE

                MOV     DX,OFFSET RWBUFFER
                MOV     CX,6
                MOV     BX,CS:_HANDLE
                MOV     AH,3FH
                INT     21H
                JC      FILEERROR
                CMP     AX,6
                JNZ     FILEERROR
                MOVZX   ECX,AX                     ;transmit counter
                MOV     CS:_READCOUNTER,0
                MOV     EAX,DWORD PTR RWBUFFER[2]
                ADD     EAX,6
                MOV     CS:_EXTENDLEN,EAX
                MOV     BX,CS:_EXTSIZE
                MOVZX   EBX,BX
                SHL     EBX,10
                SUB     EBX,EAX
                ADD     EBX,100000H
                MOV     CS:_EXTENDADDR,EBX        ;the start address
                CMP     EBX,100000H
                JB      MEMNOTENOUGH
                MOV     AX,0FEFCH
                INT     21H
                CMP     AH,0FEH
                JZ      CANENOTINMEM3
TRANSMITNEXTBLOCK:
                MOV     AX,CS
                MOVZX   EAX,AX
                SHL     EAX,4
                MOV     BX,OFFSET RWBUFFER
                MOVZX   EBX,BX
                ADD     EAX,EBX                  ;EAX SRC ADDRESS
                PUSH    EAX
                MOV     EAX,CS:_READCOUNTER
                MOV     EBX,CS:_EXTENDADDR
                ADD     EBX,EAX                  ;EBX DESC ADDRESS
                MOV     EAX,CS:_READCOUNTER
                ADD     EAX,ECX
                MOV     CS:_READCOUNTER,EAX      ;READ BYTE NUMBER
                POP     EAX
                CALL    TRANSMITDATA
                MOV     EAX,CS:_READCOUNTER
                CMP     EAX,CS:_EXTENDLEN
                JAE     CLOSEREADFILE
                MOV     ECX,CS:_EXTENDLEN
                MOV     EAX,CS:_READCOUNTER
                SUB     ECX,EAX
                CMP     ECX,400H
                JB      NOTLASTBLOCK2
                MOV     ECX,400H               ;READCOUNTER
NOTLASTBLOCK2:
                MOV     DX,OFFSET RWBUFFER
                MOV     BX,CS:_HANDLE
                MOV     AH,3FH
                INT     21H
                JC      FILEERROR
                MOVZX   ECX,AX
                JMP     TRANSMITNEXTBLOCK
CLOSEREADFILE:
                MOV     BX,CS:_HANDLE
                MOV     AH,3EH
                INT     21H             ;CLOSE FILE
                CLC
EXITREADDATA:
                POP     DS
                POP     ES
                POP     DX
                POP     CX
                POP     BX
                POP     AX
                RET
FILEERROR:
                CMP     CS:_HANDLE,0
                JZ      NOTCLOSEFILE1
                MOV     BX,CS:_HANDLE
                MOV     AH,3EH
                INT     21H
NOTCLOSEFILE1:
                MOV     DX,OFFSET DATAERROR
                CALL    SHOWSTRING
                STC
                JMP     EXITREADDATA
MEMNOTENOUGH:
                MOV     BX,CS:_HANDLE
                MOV     AH,3EH
                INT     21H
                MOV     DX,OFFSET MEMORYLACK
                CALL    SHOWSTRING
                STC
                JMP     EXITREADDATA
CANENOTINMEM3:
                MOV     BX,CS:_HANDLE
                MOV     AH,3EH
                INT     21H
                MOV     DX,OFFSET NOTINMEM
                CALL    SHOWSTRING
                STC
                JMP     EXITREADDATA
READDATAFILE    ENDP


;****************************************************************************
;* Transmit data  between extend memory and base memory                     *
;* EAX - source address   EBX - destinate address ECX - counter             *
;****************************************************************************

TRANSMITDATA    PROC    NEAR
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    DX
                PUSH    SI
                PUSH    DI
                PUSH    DS
                PUSH    ES

                MOV     DX,SEG GDTAREA
                MOV     ES,DX
                MOV     SI,OFFSET GDTAREA
                MOV     WORD PTR ES:[SI+12H],AX      ;source
                SHR     EAX,16
                MOV     BYTE PTR ES:[SI+14H],AL
                MOV     WORD PTR ES:[SI+1AH],BX      ;destinate
                SHR     EBX,16
                MOV     BYTE PTR ES:[SI+1CH],BL
                SHR     CX,1                   ;the number of word
                MOV     AH,87H
                INT     15H
                POP     ES
                POP     DS
                POP     DI
                POP     SI
                POP     DX
                POP     CX
                POP     BX
                POP     AX
                RET
TRANSMITDATA    ENDP

CHECKEXT        PROC    NEAR
                PUSH    AX
                MOV     AH,88H
                INT     15H
                MOV     CS:_EXTSIZE,AX
                POP     AX
                RET
CHECKEXT        ENDP

SETPARALLEL     PROC    NEAR
                PUSH    ES
                PUSH    FS
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    DX

                MOV     AX,0
                MOV     ES,AX
                MOV     AX,SEG _IOPORT
                MOV     FS,AX
                MOV     BX,OFFSET _IOPORT
                MOV     AX,ES:[408H]
                SHR     AX,3
                ADD     BX,AX
                MOV     CX,ES:[408H]
                AND     CX,07H
                MOV     AX,1
                SHL     AX,CL
                MOV     CL,AL
                MOV     AX,FS:[BX]
                OR      AX,CX
                SHL     CX,1
                OR      AX,CX
                SHL     CX,1
                OR      AX,CX
                MOV     FS:[BX],AX
                MOV     CX,3
CHANGEFILENAME:
                MOV     AX,ES:[408H]
                SHR     AX,CL
                SHR     AX,CL
                SHR     AX,CL
                SHR     AX,CL
                AND     AX,0FH
                CMP     AX,09H
                JBE     ISDIGIT1
                ADD     AX,7H
ISDIGIT1:
                ADD     AX,30H
                MOV     BX,3
                SUB     BX,CX
                MOV     CS:FILENAME[BX+4],AL
                CMP     CX,0
                JZ      CHANGEFILEOVER
                DEC     CX
                JMP     CHANGEFILENAME
CHANGEFILEOVER:
                POP     DX
                POP     CX
                POP     BX
                POP     AX
                POP     FS
                POP     ES
                RET
SETPARALLEL     ENDP

LAST16          EQU     $
CSEG            ENDS
                END
