#####################################################################
#                                                                   #
# File: PROT.MAK                                                    #
#                                                                   #
# Description:                                                      #
# Make file for cane. Change Asm to reflect which assembler         #
# you use.                                                          #
#                                                                   #
# Microsoft MAKE and Borlandc MAKE are different                    #
# for Microsoft MAKE use:                                           #
#    MAKE PROT.MAK                                                  #
# For Microsoft NMAKE use:                                          #
#     NMAKE -f PROT.MAK PROT                                        #
# For Borlandc use:                                                 #
#     MAKE -f PROT.MAK PROT                                         #
#                                                                   #
# *********IMPORTANT*********************                           #
# If you use this MAKE file, never have a file named PROT           #
# (with no extension) in the current directory                      #
# This is because of the method used to allow both makes to use     #
# the same MAKE file.                                               #
#                                                                   #
#####################################################################

# change to tasm or masm
# Microsoft definitions
# ASM=MASM /A /DDLL=0
# Borland definitions
ASM = TASM

prot.obj: prot.asm external.inc equmac.inc
    $(ASM) prot.asm;

code16.obj: code16.asm external.inc equmac.inc
    $(ASM) code16.asm;

int386.obj: int386.asm external.inc equmac.inc
    $(ASM) int386.asm;

tss.obj: tss.asm external.inc equmac.inc tss.inc
    $(ASM)  tss.asm;

gdt.obj: gdt.asm external.inc equmac.inc
    $(ASM) gdt.asm;

stacks.obj: stacks.asm external.inc equmac.inc
    $(ASM) stacks.asm;

#The PROT line required by borland/unix/nmake
#Regular Microsoft MAKE will warn that prot doesn't exist
#and echo the statement
prot: stacks.obj gdt.obj tss.obj int386.obj code16.obj prot.obj
    echo PROT OBJs up to date
