;***************************************************************************
;*                                                                         *
;* PROT - A softdog killer                                                 *
;* Copyright (C) 1996, by Li Wen_xian                                      *
;* All rights reserved.                                                    *
;*                                                                         *
;* This file is: GDT.ASM, the Global Descriptor Table                      *
;* defnitions                                                              *
;*                                                                         *
;***************************************************************************
;See EQUMAC.INC for an explanation of the DESC macro
INCLUDE         EQUMAC.INC
GDT_FILE        EQU     1
INCLUDE         EXTERNAL.INC
GDTSEG          SEGMENT
GDT             EQU     $               ;GDT space
                PUBLIC  GDT
                DESC    SEL_NULL        ;DUMMY NULL SELECTOR           0
                DESC    SEL_GDT         ;GDT ALIAS                     8
                DESC    SEL_CODE16      ;16 BIT CODE SEGMENT          10
                DESC    SEL_DATA0       ;4GB SEGMENT                  18
                DESC    SEL_CODE32      ;32 BIT CODE SEGMENT          20
                DESC    SEL_STACK       ;32 BIT STACK                 28
                DESC    SEL_RDATA       ;REAL MODE LIKE DATA SEG      30
                DESC    SEL_VIDEO       ;VIDEO MEMORY                 38
                DESC    SEL_DATA        ;32 BIT DATA                  40
                DESC    SEL_IDT         ;IDT ALIAS                    48
                DESC    SEL_ICODE       ;ISR SEGMENT                  50
                DESC    SEL_TSS1        ;MAIN TASK BLOCK              58
                DESC    TSS1            ;SAME (MUST FOLLOW SEL_TSS1)  60
                DESC    SEL_UCODE       ;USER CODE                    68
                DESC    SEL_UDATA       ;USER DATA                    70
                DESC    SEL_PSP         ;DOS PSP                      78
                DESC    SEL_FREE        ;FREE DOS MEMORY              80
                DESC    SEL_EXT         ;EXTENDED MEMORY              88
                DESC    SEL_ENV         ;ENVIRONMENT                  90
                DESC    SEL_TSS0        ;DUMMY TASK BLOCK (may reuse) 98
                DESC    TSS0            ;SAME (MUST FOLLOW SEL_TSS0)  A0
                DESC    SEL_15S         ;INT 15/87 SOURCE
                DESC    SEL_15D         ;INT 15/87 DESTINATON
;SPARE ENTRIES
                DESC    SEL_ISR         ;ISR ALIAS                    A8
                DESC    SPARE1          ;                             B0
                DESC    SPARE2          ;                             B8
                DESC    SPARE3          ;                             C0
                DESC    SPARE4          ;                             C8
                DESC    SPARE5          ;                             D0
                DESC    SPARE6          ;                             D8
                DESC    SPARE7          ;                             E0
                DESC    SPARE8          ;                             E8
                DESC    SPARE9          ;                             F0
                DESC    SPARE10         ;                             F8
                DESC    SPARE11         ;                            100
                DESC    SPARE12         ;                            108
                DESC    SPARE13         ;                            110
                DESC    SPARE14         ;                            118
                DESC    SPARE15         ;                            120
                DESC    SPARE16         ;                            128
                DESC    SPARE17         ;                            130
                DESC    SPARE18         ;                            138
                DESC    SPARE19         ;                            140
                DESC    SPARE20         ;                            148
                DESC    SPARE21         ;                            150
                DESC    SPARE22         ;                            158
                DESC    SPARE23         ;                            160
                DESC    SPARE24         ;                            168
                DESC    SPARE25         ;                            170
                DESC    SPARE26         ;                            178
                DESC    SPARE27         ;                            180
                DESC    SPARE28         ;                            188
                DESC    SPARE29         ;                            190
                DESC    SPARE30         ;                            198
                DESC    SPARE31         ;                            1A0
GDTEND          =       $
GDTSEG          ENDS

GDTLEN          EQU     (GDTEND-GDT)-1
                PUBLIC   GDTLEN
                END
